import java.awt.*;
import java.io.*;
import java.util.*;

public class Main {
    public static int counter(int n, int a) {
        return n - a + 1;
    }

    public static int euclid(int a, int b) {
        if (a <= b) return b;
        return euclid(Math.max(a - b, b), Math.min(a - b, b));
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int q = nextInt();
        int a[] = new int[n];
        int b[] = new int[n];
        ArrayList<ArrayList<Double>> nums = new ArrayList<>();
        for (int i = 0; i < n; i++)
            a[i] = nextInt();
        for (int i = 0; i < n; i++)
            b[i] = nextInt();
        Arrays.sort(a);
        Arrays.sort(b);
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                ArrayList<Double> doubles = new ArrayList<>();
                doubles.add((double) a[i] / b[j]);
                doubles.add((double) a[i]);
                doubles.add((double) b[j]);
                nums.add(doubles);
            }
        }
        nums.sort(new Comparator<ArrayList<Double>>() {
            @Override
            public int compare(ArrayList<Double> o1, ArrayList<Double> o2) {
                return Double.compare(o1.get(0), o2.get(0));
            }
        });
        for (int i = 0; i < q; i++) {
            int ind = nextInt() - 1;
            ArrayList<Double> ans = nums.get(ind);
            double a1 = ans.get(1);
            double a2 = ans.get(2);
            int del = euclid((int)Math.max(a1, a2), (int) Math.min(a1, a2));
            out.println(((int) a1) / del + " " + ((int) a2) / del);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }}